Name:		miopen
Version:	1.1.4
Release:	4%{?dist}
Summary:	AMD's machine intelligence library

License:	MIT
URL:		https://github.com/ROCmSoftwarePlatform/MIOpen
Source0:	https://github.com/ROCmSoftwarePlatform/MIOpen/archive/%{version}/miopen-%{version}.tar.gz
Patch0:		0001-CMake-fixes-for-building-on-Fedora.patch
Patch1:		0001-Install-to-standard-location.patch
Patch2:		0001-Fix-db-install-path.patch
Patch3:		0001-Fix-build-with-boost-1.56.patch

BuildRequires:	cmake
BuildRequires:	boost-devel
BuildRequires:	hcc
BuildRequires:	hip
BuildRequires:	openssl-devel
BuildRequires:	rocm-clang-ocl
BuildRequires:	rocm-cmake
BuildRequires:	rocm-runtime-devel

Requires:	rocm-clang-ocl

%{!?enable_llvmtoolset7: %define enable_llvmtoolset7 %{nil}}
%{!?enable_devtoolset7: %define enable_devtoolset7 %{nil}}

%if 0%{?rhel} == 7
# FIXME: Manually define enable_llvmtoolset7 until llvm-toolset-7-5.0.1 is
# available
%enable_llvmtoolset7 %global ___build_pre %{___build_pre}; source scl_source enable llvm-toolset-7 || :

BuildRequires: llvm-toolset-7-cmake
BuildRequires: llvm-toolset-7-runtime
BuildRequires: devtoolset-7-build
BuildRequires: devtoolset-7-gcc-c++

Requires: devtoolset-7-gcc-c++
%enable_llvmtoolset7
%enable_devtoolset7
%global __cmake cmake
%endif

%description
AMD's library for high peformance machine learning primitives. MIOpen supports
two programming models - OpenCL and HIP


%package devel
Summary: MIOpen development files
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
Libraries and header files for MIOpen


%prep
%setup -q -n MIOpen-%{version}
%patch0 -p1 -b .cmake-fedora
%patch1 -p1 -b .install-loc
%patch2 -p1 -b .db-install
%if 0%{?rhel} == 7
%patch3 -p1 -b .old-boost-fix
%endif


%build
mkdir build
cd build

# Don't use cmake macro because hcc does not support the default Fedora
# CXXFLAGS.
%__cmake .. \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DMIOPEN_BACKEND=HIP \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_CXX_COMPILER=%{_bindir}/hcc
make %{?_smp_mflags}


%install
cd build
%make_install


%files
%doc README.md
%license LICENSE.txt
%{_libdir}/libMIOpen.so.1
%{_datadir}/miopen

%files devel
%{_libdir}/libMIOpen.so
%{_libdir}/cmake/miopen
%{_includedir}/miopen
%{_includedir}/miopen_kernels.h


%changelog
* Fri Mar 09 2018 Tom Stellard <tstellar@redhat.com> - 1.1.4-4
- Add epel support

* Fri Mar 02 2018 Tom Stellard <tstellar@redhat.com> - 1.1.4-3
- Make the devel package depend on the main package

* Fri Mar 02 2018 Tom Stellard <tstellar@redhat.com> - 1.1.4-2
- Use the clang-ocl wrapper instead of hcc

* Tue Feb 27 2018 Tom Stellard <tstellar@redhat.com> - 1.1.4-1
- 1.1.4 Release
